#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>

#define KOM 100000000
#define LKOM 7
typedef long long ll;
struct Liczba {
	ll t[LKOM + 4];
};
struct Ulamek {
	Liczba t[2];
};
//typedef ll Liczba[LKOM];
using namespace std;

string opis[20];
int ljed;

Liczba mnoz(Liczba a, Liczba b) {
	Liczba c;
	memset(c.t, 0, sizeof(c.t));
	for(int i=0; i<LKOM; i++)
		for(int j=0; i+j<LKOM; j++) {
			c.t[i+j] += a.t[i]*b.t[j];
			if (i+j+1 < LKOM) {
				c.t[i+j+1] += c.t[i+j]/KOM;
				c.t[i+j] %= KOM;
			}
		}
	return c;
}

int porow(Liczba a, Liczba b) {
	for(int i=LKOM; i>=0;i--) {
		int d = a.t[i] - b.t[i];
		if (d<0) return -1;
		else if (d> 0) return 1;
	}
	return 0;
}

Liczba roznica(Liczba a, Liczba b) {
	Liczba c;
	memset(c.t, 0, sizeof(c.t));
	if (porow(a,b) < 0) swap(a,b);
	for(int i=0; i<LKOM;i++) {
		c.t[i] += a.t[i] - b.t[i];
		if (c.t[i] < 0) {
			c.t[i] += KOM;
			if (i+1 < LKOM) {
				c.t[i+1]--;
			}
		}
	}
	//printf("dob\n");
	return c;
}

Liczba doLiczba(ll x) {
	Liczba wyn; memset(wyn.t, 0, sizeof(wyn.t));
	wyn.t[0] = x;
	return wyn;
}

int dodaj(const string &s) {
	for(int i=0; i<ljed; i++) {
		if (opis[i] == s) return i;
	}
	opis[ljed] = s;
	ljed++;
	return ljed-1;
}

int porow(Ulamek a, Ulamek b) {
	Liczba h1, h2;
	h1 = mnoz(a.t[0], b.t[1]);
	h2 = mnoz(a.t[1], b.t[0]);
	return porow(h1, h2);
}

Ulamek roznica(Ulamek a, Ulamek b) {
	Liczba h1, h2;
	Ulamek wyn;
	h1 = mnoz(a.t[0], b.t[1]);
	h2 = mnoz(a.t[1], b.t[0]);

	wyn.t[0] = roznica(h1, h2);
	//printf("dobrze\n");
	wyn.t[1] = mnoz(a.t[1], b.t[1]);
	return wyn;
}

Ulamek doUlamek(ll a, ll b){
	//printf("doUlamek %Li %Li\n",a, b);
	Ulamek wyn;
	wyn.t[0] = doLiczba(a);
	wyn.t[1] = doLiczba(b);
	return wyn;
}

Ulamek mnoz(Ulamek u, Ulamek v) {
	Ulamek wyn;
	wyn.t[0] = mnoz(u.t[0], v.t[0]);
	wyn.t[1] = mnoz(u.t[1], v.t[1]);
	return wyn;
}
/*
bool rowne(long double a, long double b) {
	const long double ZERO = 1e-19;
	if (abs(a - b) < ZERO) return true;
	else return false;
}
*/

char wzorcelin[50][50];
Ulamek mat[20][20];

int main() {
	int zestaw;
	bool bylo[20][20];
	scanf("%d", &zestaw);
	while (zestaw--) {
		memset(bylo, 0, sizeof(bylo));
		memset(mat, 0, sizeof(mat));
		int p,x;
		char buf[20];
		scanf("%d", &p);
		for(int i = 0; i<p; i++) {
			string s;
			scanf("%x %s",&x, buf);
			s = buf;
			int nra = dodaj(s);
			scanf(" = %d %s",&x, buf);
			s = buf;
			int nrb = dodaj(s);
			bylo[nra][nrb] = true;
			bylo[nrb][nra] = true;
			mat[nra][nra]=doUlamek(1,1);
			mat[nrb][nrb]=doUlamek(1,1);
			bylo[nra][nra] = true;
			bylo[nrb][nrb] = true;
			mat[nra][nrb] = doUlamek(x,1);
			mat[nrb][nra] = doUlamek(1,x);
		}
		for(int k=0; k<ljed; k++) 
			for(int i=0; i< ljed; i++)
				for(int j=0; j<ljed; j++) 
					if (bylo[i][k] && bylo[k][j]) {
						mat[i][j] = mnoz(mat[i][k],mat[k][j]);
						bylo[i][j] = true;
					}
		/*
		for(int i=0; i<ljed; i++)
			for(int j=0; j<ljed; j++) 
				for(int k = 0; k< 2; k++)
					for(int l=0; l< LKOM; l++) {
						//printf("%i %.10f\n", (int)bylo[i][j], mat[i][j]);
						printf("%Ld\n", mat[i][j].t[k].t[l]);
					}
					*/
		Ulamek wzorced[50];
		string wzorces[50];
		int lwzor;
		scanf("%d",&lwzor);
		for(int i=0; i<lwzor; i++) {
			int h;
			scanf("%i %s", &h, buf);
			//printf("%i %s\n", (int)wzorced[i], buf);
			sprintf(wzorcelin[i],"%i %s", (int)h, buf);
			//sprintf(wzorcelin[i], "%Lf %s\n", wzorced[i], buf);
			//sprintf(wzorcelin[i], "%d %s", (int)wzorced[i], buf);
			//printf("%s\n", wzorcelin[i]);
			wzorces[i] = buf;
			int num = dodaj(wzorces[i]);
			wzorced[i] = mnoz(doUlamek(h, 1) , mat[num][0]);
			//printf("%d", wzorced[i]);
		}
		scanf("%d",&p);
		for(int i=0; i<p; i++) {
			int h;
			scanf("%i %s", &h, buf);
			//printf("%i %s\n", (int)h, buf);
			int num = dodaj(buf);
		   	Ulamek u = mnoz(doUlamek(h, 1) , mat[num][0]);
			int wzmin = 0;
			for(int j=0; j<lwzor; j++) {
				/*for(int k = 0; k< 2; k++)
					for(int l=0; l< LKOM; l++) {
					//printf("%i %.10f\n", (int)bylo[i][j], mat[i][j]);
					printf("%Ld\n", wzorced[wzmin].t[k].t[l]);
				}*/
				//printf("dobrze\n");
				Ulamek dmin = roznica(u,wzorced[wzmin]);
				Ulamek nd = roznica(u,wzorced[j]);
				if (porow(dmin, nd)== 0 && porow(wzorced[j], wzorced[wzmin]) < 0) wzmin = j;
				else if (porow(nd, dmin)<0) wzmin = j;
			}
			printf("%s\n", wzorcelin[wzmin]);
		}
	}
	return 0;
}
